%--------------------------------------------------------------------------
res=0.1;
res=1;
res=1/3;
st_res=num2str(res,1);
st_res=strrep(st_res,'.','');

dx=res;
dy=res;

%--------------------------------------------------------------------------
nx=360/res;
ny=180/res;
dx=360/nx;
dy=180/ny;   
lon=linspace(-180+dx/2,180-dx/2,nx);
lat=linspace(90-dx/2,-90+dx/2,ny);
[Lat,Lon]=ndgrid(lat,lon);

%--------------------------------------------------------------------------
load coast
lat_coast=lat;
long_coast=long;
clear lat long
states = shaperead('usastatehi', 'UseGeoCoords', true);
rivers = shaperead('worldrivers', 'UseGeoCoords', true);
cities = shaperead('worldcities', 'UseGeoCoords', true);
lakes = shaperead('worldlakes', 'UseGeoCoords', true);
% Create a symbolspec to make Alaska and Hawaii polygons red.
symspec = makesymbolspec('Polygon', ...
   {'Name', 'Alaska', 'FaceColor', 'red'}, ...
   {'Name', 'Hawaii', 'FaceColor', 'red'});   

%--------------------------------------------------------------------------
% State Masks
mask_dir='Masks/';

%--------------------------------------------------------------------------
load('PM25_2000_2012_average.mat')
R=makerefmat('RasterSize',size(PM25_average),'Latlim',[-90 90],'Lonlim',[-180 180]);

%--------------------------------------------------------------------------
dir_base='./';
name_base=['test'];    
fn_base=[dir_base name_base];  

out_dir='./';

%--------------------------------------------------------------------------
worldmap('world');
geoshow(flipud(PM25_average),R,'DisplayType','texturemap');
geoshow(states, 'SymbolSpec', symspec, ...
   'EdgeColor', 'black','FaceColor', 'none');    
plotm(lat_coast,long_coast,'LineWidth',1,'Color','black')
geoshow(rivers, 'Color', 'blue')

caxis([-1 50]);
map2 = colormap; map2( 1, : ) = 1; colormap(map2);

colorbar

title(['Global Average PM2.5'],'FontSize',30)
drawnow

%--------------------------------------------------------------------------

array=PM25_average;
fmt='png';

C=array;
n=size(C);
cmin=min(min(array));
cmax=max(max(array));
cmin=-0.1;
cmax=30;
m=length(map2);
index = fix((C-cmin)/(cmax-cmin)*m);
index(index<1) = 1;
index(index>m) = m; 
index=reshape(index,n(1)*n(2),1);
ns=[size(array) 3];
A=ones(ns,'uint8');
iwant=find(isnan(index));
index(iwant)=1;
if cmin==cmax
    iwant=find(C==cmin);
    index(iwant)=2;    
end
A=map2(index,:,:);
A=reshape(A,n(1),n(2),3);
fn_ge=[fn_base '-earth.png'];

imwrite(A,fn_ge,fmt,'Background',[1 1 1],'Transparency',[1 1 1]);

%--------------------------------------------------------------------------
% Script to make background transparent using imagemagick command line 
% tools from http://www.imagemagick.org/
% fid_sh = fopen([fn_base '.sh'],'w');
% command=['echo /usr/local/bin/convert ' fn_base '-earth.png -transparent white ' fn_base '-earth.png'];
% fprintf(fid_sh, '%s \n', command);
% 
% command=['/usr/local/bin/convert ' fn_base '-earth.png -transparent white ' fn_base '-earth.png'];
% fprintf(fid_sh, '%s \n', command);
% fclose(fid_sh);    
% 
% system(command);
% 
%--------------------------------------------------------------------------
% KML file
lat_hi=90;
lat_lo=-90
lon_hi=180;
lon_lo=-180;

fn_kml=[fn_base '.kml'];
fid = fopen(fn_kml, 'w');

% kml header
string='<?xml version="1.0" encoding="UTF-8"?><kml xmlns="http://earth.google.com/kml/2.2">';
fprintf(fid, '%s \n', string);
string=['<description>Average PM2.5 estimate for 3/1/2000-3/1/2012</description>'];
fprintf(fid, '%s \n', string);
string='<Document>';
fprintf(fid, '%s \n', string);
string='<open>1</open>';
fprintf(fid, '%s \n', string);

string='';
fprintf(fid, '%s \n', string);

string='<GroundOverlay>';
fprintf(fid, '%s \n', string);
string=['<name>Average PM2.5 estimate for 3/1/2000-3/1/2012</name>'];
fprintf(fid, '%s \n', string);
string=['<visibility>1</visibility>'];
fprintf(fid, '%s \n', string);
string='<Icon>';
fprintf(fid, '%s \n', string);
string=['  <href>' name_base '-earth.png</href>'];
fprintf(fid, '%s \n', string);
string='</Icon>';
fprintf(fid, '%s \n', string);
string='<LatLonBox>';
fprintf(fid, '%s \n', string);
string=['  <north>' num2str(lat_hi) '</north>'];
fprintf(fid, '%s \n', string);
string=['  <south>' num2str(lat_lo) '</south>'];
fprintf(fid, '%s \n', string);
string=['  <east>' num2str(lon_hi) '</east>'];
fprintf(fid, '%s \n', string);
string=['  <west>' num2str(lon_lo) '</west>'];
fprintf(fid, '%s \n', string);
string='</LatLonBox>';
fprintf(fid, '%s \n', string);
string='</GroundOverlay>';
fprintf(fid, '%s \n', string);

% kml footer
string='</Document>';
fprintf(fid, '%s \n', string);
string='</kml>';
fprintf(fid, '%s \n', string);

fclose(fid);
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% State Rankings

%--------------------------------------------------------------------------
pm25_states=zeros(length(states),1);
iwant=find(pm25_states==0);
pm25_states(iwant)=NaN;

for i=1:length(states)

    name=states(i).Name;
    name=strrep(name,' ','');
    name=strrep(name,'(','');
    name=strrep(name,')','');
    name=strrep(name,',','');
    name=strrep(name,'''','');
    name=strrep(name,'','A');
    name=strrep(name,'-','_');

    var_name=['usa_' name '_mask'];
    fn_mat=[mask_dir var_name '_' st_res '_' st_res  '.mat'];

    if exist(fn_mat,'file')
        
        %disp(fn_mat)
        load(fn_mat)
        
        command=['iwant=find(' var_name ');'];
        eval(command);
        
        pm25_states(i)=nanmean(PM25_average(iwant));
        disp([name ':' num2str(pm25_states(i))])
        
    else

        disp([fn_mat ' does not exist.'])
        
    end

end

%--------------------------------------------------------------------------
% Sort into descending order
clear B IX
[B,IX] = sort(pm25_states,'descend');

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Display results
fn_tex=[out_dir 'State_table.tex'];
disp(fn_tex);
fid = fopen(fn_tex, 'w');

%--------------------------------------------------------------------------
string=['\documentclass[10pt]{article}'];
fprintf(fid, '%s \n', string);

string=['\begin{document}'];
fprintf(fid, '%s \n', string);

string=['\topmargin =-1in'];
fprintf(fid, '%s \n', string);

string=['\pagestyle{empty}'];
fprintf(fid, '%s \n', string);

string=['\begin{table}'];
fprintf(fid, '%s \n', string);

string=['\small'];
fprintf(fid, '%s \n', string);

string=['\caption*{States ranked by the average estimated ground level abundance of PM$_{2.5}$. PM$_{2.5}$ is given in units of $\mu g/m^3$ over the period March 1, 2000 through March 31, 2012.}'];
fprintf(fid, '%s \n', string);

string=['\begin{center}'];
fprintf(fid, '%s \n', string);

string=['\begin{tabular}{lll}'];
fprintf(fid, '%s \n', string);

string=[' &  & ($\mu g/m^3$)\\'];
fprintf(fid, '%s \n', string);

string=['Rank & State & $\langle PM_{2.5} \rangle$ \\[0.02in] '];
fprintf(fid, '%s \n', string);

string=['\hline'];
fprintf(fid, '%s \n', string);

string=['\\[-0.1in]'];
fprintf(fid, '%s \n', string);

%--------------------------------------------------------------------------
jcount=0;
for j=1:length(pm25_states)
    
    i=IX(j);
    if ~isnan(pm25_states(i))
        
        jcount=jcount+1;
        
        name=states(i).Name;
        
        x(jcount)=jcount;
        y(jcount)=pm25_states(i);
        bar_State{jcount}=name;

        ending=['\\'];
        if mod(jcount,10)==0
            ending=[ending '[0.1in]'];
        end
        string=[num2str(jcount) ' & ' name ' & '  num2str(pm25_states(i),'%6.1f')  ending];
        fprintf(fid, '%s \n', string);

        disp([name ': PM2.5 estimate ' num2str(pm25_states(i),'%6.1f') ])

                
    end
end

%--------------------------------------------------------------------------
string=['\hline'];
fprintf(fid, '%s \n', string);

string=['\end{tabular}'];
fprintf(fid, '%s \n', string);

string=['\end{center}'];
fprintf(fid, '%s \n', string);

string=['\label{default}'];
fprintf(fid, '%s \n', string);

string=['\end{table}'];
fprintf(fid, '%s \n', string);

string=['\end{document}'];
fprintf(fid, '%s \n', string);

fclose(fid);
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% End State Rankings


